// Code generated by protoc-gen-go-http. DO NOT EDIT.
// Source: legacy_upstream.proto

package pb

import (
	context "context"
	transport "github.com/erda-project/erda-infra/pkg/transport"
	http "github.com/erda-project/erda-infra/pkg/transport/http"
	urlenc "github.com/erda-project/erda-infra/pkg/urlenc"
	http1 "net/http"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the "github.com/erda-project/erda-infra/pkg/transport/http" package it is being compiled against.
const _ = http.SupportPackageIsVersion1

// UpstreamServiceHandler is the server API for UpstreamService service.
type UpstreamServiceHandler interface {
	// PUT /api/gateway/register
	Register(context.Context, *RegisterRequest) (*RegisterResponse, error)
	// PUT /api/gateway/register_async
	AsyncRegister(context.Context, *AsyncRegisterRequest) (*AsyncRegisterResponse, error)
}

// RegisterUpstreamServiceHandler register UpstreamServiceHandler to http.Router.
func RegisterUpstreamServiceHandler(r http.Router, srv UpstreamServiceHandler, opts ...http.HandleOption) {
	h := http.DefaultHandleOptions()
	for _, op := range opts {
		op(h)
	}
	encodeFunc := func(fn func(http1.ResponseWriter, *http1.Request) (interface{}, error)) http.HandlerFunc {
		return func(w http1.ResponseWriter, r *http1.Request) {
			out, err := fn(w, r)
			if err != nil {
				h.Error(w, r, err)
				return
			}
			if err := h.Encode(w, r, out); err != nil {
				h.Error(w, r, err)
			}
		}
	}

	add_Register := func(method, path string, fn func(context.Context, *RegisterRequest) (*RegisterResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*RegisterRequest))
		}
		var Register_info transport.ServiceInfo
		if h.Interceptor != nil {
			Register_info = transport.NewServiceInfo("erda.core.hepa.legacy_upstream.UpstreamService", "Register", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, Register_info)
				}
				r = r.WithContext(ctx)
				var in RegisterRequest
				if err := h.Decode(r, &in.Upstream); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_AsyncRegister := func(method, path string, fn func(context.Context, *AsyncRegisterRequest) (*AsyncRegisterResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*AsyncRegisterRequest))
		}
		var AsyncRegister_info transport.ServiceInfo
		if h.Interceptor != nil {
			AsyncRegister_info = transport.NewServiceInfo("erda.core.hepa.legacy_upstream.UpstreamService", "AsyncRegister", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, AsyncRegister_info)
				}
				r = r.WithContext(ctx)
				var in AsyncRegisterRequest
				if err := h.Decode(r, &in.Upstream); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_Register("PUT", "/api/gateway/register", srv.Register)
	add_AsyncRegister("PUT", "/api/gateway/register_async", srv.AsyncRegister)
}
