// Code generated by protoc-gen-go-client. DO NOT EDIT.
// Sources: protocol.proto

package client

import (
	fmt "fmt"
	reflect "reflect"
	strings "strings"

	servicehub "github.com/erda-project/erda-infra/base/servicehub"
	grpc "github.com/erda-project/erda-infra/pkg/transport/grpc"
	pb "github.com/erda-project/erda-proto-go/cp/pb"
	grpc1 "google.golang.org/grpc"
)

var dependencies = []string{
	"grpc-client@erda.cp",
	"grpc-client",
}

// +provider
type provider struct {
	client Client
}

func (p *provider) Init(ctx servicehub.Context) error {
	var conn grpc.ClientConnInterface
	for _, dep := range dependencies {
		c, ok := ctx.Service(dep).(grpc.ClientConnInterface)
		if ok {
			conn = c
			break
		}
	}
	if conn == nil {
		return fmt.Errorf("not found connector in (%s)", strings.Join(dependencies, ", "))
	}
	p.client = New(conn)
	return nil
}

var (
	clientsType         = reflect.TypeOf((*Client)(nil)).Elem()
	cpserviceClientType = reflect.TypeOf((*pb.CPServiceClient)(nil)).Elem()
	cpserviceServerType = reflect.TypeOf((*pb.CPServiceServer)(nil)).Elem()
)

func (p *provider) Provide(ctx servicehub.DependencyContext, args ...interface{}) interface{} {
	var opts []grpc1.CallOption
	for _, arg := range args {
		if opt, ok := arg.(grpc1.CallOption); ok {
			opts = append(opts, opt)
		}
	}
	switch ctx.Service() {
	case "erda.cp-client":
		return p.client
	case "erda.cp.CPService":
		return &cpserviceWrapper{client: p.client.CPService(), opts: opts}
	case "erda.cp.CPService.client":
		return p.client.CPService()
	}
	switch ctx.Type() {
	case clientsType:
		return p.client
	case cpserviceClientType:
		return p.client.CPService()
	case cpserviceServerType:
		return &cpserviceWrapper{client: p.client.CPService(), opts: opts}
	}
	return p
}

func init() {
	servicehub.Register("erda.cp-client", &servicehub.Spec{
		Services: []string{
			"erda.cp.CPService",
			"erda.cp-client",
		},
		Types: []reflect.Type{
			clientsType,
			// client types
			cpserviceClientType,
			// server types
			cpserviceServerType,
		},
		OptionalDependencies: dependencies,
		Creator: func() servicehub.Provider {
			return &provider{}
		},
	})
}
