// Copyright (c) 2021 Terminus, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package utils

import (
	"math"
	"regexp"
)

// Round 保留小数点计算
func Round(f float64, n int) float64 {
	shift := math.Pow(10, float64(n))
	fv := 0.0000000001 + f //对浮点数产生.xxx999999999 计算不准进行处理

	return math.Floor(fv*shift+.5) / shift
}

var svcRegexp, _ = regexp.Compile(`^[a-z0-9]+([-]*[a-z0-9])+$`)

// IsValidK8sSvcName is valid service name
func IsValidK8sSvcName(name string) bool {
	return svcRegexp.MatchString(name) && len(name) <= 63
}
